PingOne Platform APIs

Send risk evaluation feedback

POST {{apiPath}}/v1/environments/{{envID}}/riskFeedback

This sample uses the riskFeedback endpoint to send feedback regarding the results of a single risk evaluation that was carried out.

The body of the request includes the required occurredFrom field but does not include the occurredTo field, which is required only when subject.type is set to TIME_RANGE.

The Content-Type header request is set to application/vnd.pingidentity.risk.feedback.v2+json. This instructs PingOne to use risk evaluation feedback v2.

Prerequisites

Request Model

For complete property descriptions, refer to Risk evaluation feedback data model - v2

Property Type Required

analyst

String

Optional

attributes

Object

Optional

confidence

String

Optional

confirmedAt

String

Optional

flowType

String

Optional

fraudType

String

Optional

occurredFrom

Date

Required

reason

String

Optional

subject

Object

Required

subject.type

String

Required

subject.value`

String

Required

trigger

String

Optional

verdict

String

Required

Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/vnd.pingidentity.risk.feedback.v2+json

Body

raw ( application/vnd.pingidentity.risk.feedback.v2+json )

{
    "subject": {
        "type": "RISK_EVALUATION_ID",
        "value": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
    },
    "verdict": "FRAUD",
    "trigger": "CHARGEBACK",
    "flowType": "TRANSACTION",
    "fraudType" : "account takeover",
    "occurredFrom": "2026-05-14T10:30:00.000Z",
    "confirmedAt": "2026-05-15T10:30:00.000Z",
    "reason": "An end user reported unauthorized pay transaction",
    "analyst": "analyst_1234@example.com",
    "confidence": "HIGH",
    "attributes": {
        "userPhoneNumber": "+1.5125551111"
    }
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/riskFeedback' \
--header 'Content-Type: application/vnd.pingidentity.risk.feedback.v2+json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data-raw '{
    "subject": {
        "type": "RISK_EVALUATION_ID",
        "value": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
    },
    "verdict": "FRAUD",
    "trigger": "CHARGEBACK",
    "flowType": "TRANSACTION",
    "fraudType" : "account takeover",
    "occurredFrom": "2026-05-14T10:30:00.000Z",
    "confirmedAt": "2026-05-15T10:30:00.000Z",
    "reason": "An end user reported unauthorized pay transaction",
    "analyst": "analyst_1234@example.com",
    "confidence": "HIGH",
    "attributes": {
        "userPhoneNumber": "+1.5125551111"
    }
}'
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/riskFeedback")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/vnd.pingidentity.risk.feedback.v2+json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""subject"": { " + "\n" +
@"        ""type"": ""RISK_EVALUATION_ID""," + "\n" +
@"        ""value"": ""d1b638b4-638e-4c56-8fc6-872691c1bab1"" " + "\n" +
@"    }," + "\n" +
@"    ""verdict"": ""FRAUD""," + "\n" +
@"    ""trigger"": ""CHARGEBACK""," + "\n" +
@"    ""flowType"": ""TRANSACTION""," + "\n" +
@"    ""fraudType"" : ""account takeover""," + "\n" +
@"    ""occurredFrom"": ""2026-05-14T10:30:00.000Z""," + "\n" +
@"    ""confirmedAt"": ""2026-05-15T10:30:00.000Z""," + "\n" +
@"    ""reason"": ""An end user reported unauthorized pay transaction""," + "\n" +
@"    ""analyst"": ""analyst_1234@example.com""," + "\n" +
@"    ""confidence"": ""HIGH""," + "\n" +
@"    ""attributes"": {" + "\n" +
@"        ""userPhoneNumber"": ""+1.5125551111""" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/riskFeedback"
  method := "POST"

  payload := strings.NewReader(`{
    "subject": {
        "type": "RISK_EVALUATION_ID",
        "value": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
    },
    "verdict": "FRAUD",
    "trigger": "CHARGEBACK",
    "flowType": "TRANSACTION",
    "fraudType" : "account takeover",
    "occurredFrom": "2026-05-14T10:30:00.000Z",
    "confirmedAt": "2026-05-15T10:30:00.000Z",
    "reason": "An end user reported unauthorized pay transaction",
    "analyst": "analyst_1234@example.com",
    "confidence": "HIGH",
    "attributes": {
        "userPhoneNumber": "+1.5125551111"
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/vnd.pingidentity.risk.feedback.v2+json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /v1/environments/{{envID}}/riskFeedback HTTP/1.1
Host: {{apiPath}}
Content-Type: application/vnd.pingidentity.risk.feedback.v2+json
Authorization: Bearer {{accessToken}}

{
    "subject": {
        "type": "RISK_EVALUATION_ID",
        "value": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
    },
    "verdict": "FRAUD",
    "trigger": "CHARGEBACK",
    "flowType": "TRANSACTION",
    "fraudType" : "account takeover",
    "occurredFrom": "2026-05-14T10:30:00.000Z",
    "confirmedAt": "2026-05-15T10:30:00.000Z",
    "reason": "An end user reported unauthorized pay transaction",
    "analyst": "analyst_1234@example.com",
    "confidence": "HIGH",
    "attributes": {
        "userPhoneNumber": "+1.5125551111"
    }
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/vnd.pingidentity.risk.feedback.v2+json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"subject\": { \n        \"type\": \"RISK_EVALUATION_ID\",\n        \"value\": \"d1b638b4-638e-4c56-8fc6-872691c1bab1\" \n    },\n    \"verdict\": \"FRAUD\",\n    \"trigger\": \"CHARGEBACK\",\n    \"flowType\": \"TRANSACTION\",\n    \"fraudType\" : \"account takeover\",\n    \"occurredFrom\": \"2026-05-14T10:30:00.000Z\",\n    \"confirmedAt\": \"2026-05-15T10:30:00.000Z\",\n    \"reason\": \"An end user reported unauthorized pay transaction\",\n    \"analyst\": \"analyst_1234@example.com\",\n    \"confidence\": \"HIGH\",\n    \"attributes\": {\n        \"userPhoneNumber\": \"+1.5125551111\"\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/riskFeedback")
  .method("POST", body)
  .addHeader("Content-Type", "application/vnd.pingidentity.risk.feedback.v2+json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/riskFeedback",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/vnd.pingidentity.risk.feedback.v2+json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "subject": {
      "type": "RISK_EVALUATION_ID",
      "value": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
    },
    "verdict": "FRAUD",
    "trigger": "CHARGEBACK",
    "flowType": "TRANSACTION",
    "fraudType": "account takeover",
    "occurredFrom": "2026-05-14T10:30:00.000Z",
    "confirmedAt": "2026-05-15T10:30:00.000Z",
    "reason": "An end user reported unauthorized pay transaction",
    "analyst": "analyst_1234@example.com",
    "confidence": "HIGH",
    "attributes": {
      "userPhoneNumber": "+1.5125551111"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/riskFeedback',
  'headers': {
    'Content-Type': 'application/vnd.pingidentity.risk.feedback.v2+json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "subject": {
      "type": "RISK_EVALUATION_ID",
      "value": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
    },
    "verdict": "FRAUD",
    "trigger": "CHARGEBACK",
    "flowType": "TRANSACTION",
    "fraudType": "account takeover",
    "occurredFrom": "2026-05-14T10:30:00.000Z",
    "confirmedAt": "2026-05-15T10:30:00.000Z",
    "reason": "An end user reported unauthorized pay transaction",
    "analyst": "analyst_1234@example.com",
    "confidence": "HIGH",
    "attributes": {
      "userPhoneNumber": "+1.5125551111"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/riskFeedback"

payload = json.dumps({
  "subject": {
    "type": "RISK_EVALUATION_ID",
    "value": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
  },
  "verdict": "FRAUD",
  "trigger": "CHARGEBACK",
  "flowType": "TRANSACTION",
  "fraudType": "account takeover",
  "occurredFrom": "2026-05-14T10:30:00.000Z",
  "confirmedAt": "2026-05-15T10:30:00.000Z",
  "reason": "An end user reported unauthorized pay transaction",
  "analyst": "analyst_1234@example.com",
  "confidence": "HIGH",
  "attributes": {
    "userPhoneNumber": "+1.5125551111"
  }
})
headers = {
  'Content-Type': 'application/vnd.pingidentity.risk.feedback.v2+json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/riskFeedback');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/vnd.pingidentity.risk.feedback.v2+json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "subject": { \n        "type": "RISK_EVALUATION_ID",\n        "value": "d1b638b4-638e-4c56-8fc6-872691c1bab1" \n    },\n    "verdict": "FRAUD",\n    "trigger": "CHARGEBACK",\n    "flowType": "TRANSACTION",\n    "fraudType" : "account takeover",\n    "occurredFrom": "2026-05-14T10:30:00.000Z",\n    "confirmedAt": "2026-05-15T10:30:00.000Z",\n    "reason": "An end user reported unauthorized pay transaction",\n    "analyst": "analyst_1234@example.com",\n    "confidence": "HIGH",\n    "attributes": {\n        "userPhoneNumber": "+1.5125551111"\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/riskFeedback")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/vnd.pingidentity.risk.feedback.v2+json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "subject": {
    "type": "RISK_EVALUATION_ID",
    "value": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
  },
  "verdict": "FRAUD",
  "trigger": "CHARGEBACK",
  "flowType": "TRANSACTION",
  "fraudType": "account takeover",
  "occurredFrom": "2026-05-14T10:30:00.000Z",
  "confirmedAt": "2026-05-15T10:30:00.000Z",
  "reason": "An end user reported unauthorized pay transaction",
  "analyst": "analyst_1234@example.com",
  "confidence": "HIGH",
  "attributes": {
    "userPhoneNumber": "+1.5125551111"
  }
})

response = http.request(request)
puts response.read_body
let parameters = "{\n    \"subject\": { \n        \"type\": \"RISK_EVALUATION_ID\",\n        \"value\": \"d1b638b4-638e-4c56-8fc6-872691c1bab1\" \n    },\n    \"verdict\": \"FRAUD\",\n    \"trigger\": \"CHARGEBACK\",\n    \"flowType\": \"TRANSACTION\",\n    \"fraudType\" : \"account takeover\",\n    \"occurredFrom\": \"2026-05-14T10:30:00.000Z\",\n    \"confirmedAt\": \"2026-05-15T10:30:00.000Z\",\n    \"reason\": \"An end user reported unauthorized pay transaction\",\n    \"analyst\": \"analyst_1234@example.com\",\n    \"confidence\": \"HIGH\",\n    \"attributes\": {\n        \"userPhoneNumber\": \"+1.5125551111\"\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/riskFeedback")!,timeoutInterval: Double.infinity)
request.addValue("application/vnd.pingidentity.risk.feedback.v2+json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

201 Created

{
  "_links": {
    "environment": {
      "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    }
  },
  "id": "f4100382-1107-4583-b375-b355428ceb95",
  "environment": {
    "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
  },
  "subject": {
    "type": "RISK_EVALUATION_ID",
    "value": "d1b638b4-638e-4c56-8fc6-872691c1bab1"
  },
  "verdict": "FRAUD",
  "occurredFrom": "2026-05-14T10:30:00.000Z",
  "trigger": "CHARGEBACK",
  "flowType": "TRANSACTION",
  "confirmedAt": "2026-05-15T10:30:00.000Z",
  "reason": "An end user reported unauthorized pay transaction",
  "analyst": "analyst_1234@example.com",
  "confidence": "HIGH",
  "fraudType": "account takeover",
  "attributes": {
    "userPhoneNumber": "+1.5125551111"
  },
  "createdAt": "2026-11-02T09:13:29.121Z",
  "updatedAt": "2026-11-02T09:13:29.121Z"
}